#ifndef _TIMER_H
#define _TIMER_H

#include <string>

struct TimerImpl;

class Timer {
    public:
        static void init();

        Timer(const char *s = nullptr);
        ~Timer();
        const std::string & name() const { return _name; }

        void start();
        void stop();
        double elapsed() { return _elapsed; };
        void reset() { _elapsed = 0.0; };

    private:
        std::string _name;
        double _elapsed;
        TimerImpl * _impl;
};

#endif
