#! /usr/bin/env python

import subprocess, os, sys, math, argparse, platform

if not os.path.exists('build'):
    os.makedirs('build')

if platform.system() == "Windows":
    generator = "Ninja"
    compileCmd = "ninja"
elif platform.system() == "Linux":
    generator = "Unix Makefiles"
    compileCmd = "make"

configCmd = ["cmake", "-G" + generator, "-S", "src", "-B", "build"]
print(' '.join(configCmd))

if subprocess.run(configCmd).returncode != 0:
    raise Exception("erreur configure")

print(compileCmd)
if subprocess.run(compileCmd, cwd = "build").returncode != 0:
    raise Exception("erreur compile")
