#! /usr/bin/env python

import subprocess, os, sys, math, argparse, platform

baseDir = os.getcwd()
srcDir = os.path.join(baseDir, 'src')
buildDir = os.path.join(baseDir, 'build')

if platform.system() == "Windows":
    generator = "Ninja"
    compileCmd = "ninja"
elif platform.system() == "Linux":
    generator = "Unix Makefiles"
    compileCmd = "make"

configCmd = ["cmake", "-G" + generator, "-S", srcDir, "-B", buildDir]
print(' '.join(configCmd))

subprocess.call(configCmd)
subprocess.call(compileCmd, cwd = buildDir)
