#! /usr/bin/env python

import subprocess, os, sys, math, argparse
try:
  import matplotlib
  import matplotlib.pyplot as plt
  graph = True
except:
  graph = False

parser = argparse.ArgumentParser()
parser.add_argument('-n', type=int, default=7)
args = parser.parse_args()

n = args.n
x = []
m1 = []
m2 = []
d = []

k = 10
print("              localites temporelles")
print("taille          'bonne'      'mauvaise'   difference")
for i in range(n):
    k *= 10
    x.append(k)
    p = subprocess.Popen(['./build/ex_1_3', str(k)], stdout=subprocess.PIPE)
    out, err = p.communicate()
    s = b"'bonne' loc. temporelle "
    p = out.find(s) + len(s)
    m1.append(float(out[p:].split()[0]))
    s = b"'mauvaise' loc. temporelle "
    p = out.find(s) + len(s)
    m2.append(float(out[p:].split()[0]))
    d.append(100.0*(m2[-1]-m1[-1])/m1[-1])
    print("{:>10d} {:12.3g}    {:12.3g} {:12.3g} ({:+7.1f} %)".format(k, m1[-1], m2[-1], 
                                                               m2[-1]-m1[-1], d[-1]))

if graph:
  plt.figure()

  plt.semilogx(x, d, "ro-")
  plt.axhline(0)
  plt.xlabel('taille vecteur')
  plt.suptitle("difference localites temporelles (en %)")
  plt.title("('mauvaise' localite - 'bonne' localite)")
  plt.savefig('localite_temporelle.pdf') 
  plt.show()
