#! /usr/bin/env python

import subprocess, os, sys, math, argparse, platform

parser = argparse.ArgumentParser()
parser.add_argument('-version', default='Debug', choices=['Debug', 'Release'])
args = parser.parse_args()

baseDir = os.getcwd()
srcDir = os.path.join(baseDir, 'src')
buildDir = os.path.join(baseDir, 'build', args.version)

if platform.system() == "Windows":
    generator = "Ninja"
    compileCmd = "ninja"
elif platform.system() == "Linux":
    generator = "Unix Makefiles"
    compileCmd = "make"

configCmd = ["cmake", "-G" + generator, "-S", srcDir, "-B", buildDir, '-DCMAKE_BUILD_TYPE=' + args.version]
print(' '.join(configCmd))

subprocess.call(configCmd)
subprocess.call(compileCmd, cwd = buildDir)
